import general
import glob
import os


def keys_permissions():
    return all(general.exact_permission(i, "-rw-------", 0) for i in glob.glob("/etc/ssh/**/ssh_host_*_key", recursive=True))


def pubkeys_permissions():
    return all(general.exact_permission(i, "-rw-------", 0) for i in glob.glob("/etc/ssh/**/ssh_host_*_key.pub", recursive=True))


def max_auth_tries():
    # only allowed values are 0,1,2,3,4
    # default is 6 and not allowed
    return not os.path.isfile("/etc/ssh/sshd_config") or (general.grep(r'(?i)^MaxAuthTries\s+', '/etc/ssh/sshd_config') and not general.grep(r'(?i)^MaxAuthTries\s+(?![0-4]$).*$', '/etc/ssh/sshd_config'))


def root_login():
    return not os.path.isfile("/etc/ssh/sshd_config") or (general.grep(r'(?i)^permitrootlogin', '/etc/ssh/sshd_config') and not general.grep(r'(?i)^permitrootlogin\\s+yes$', '/etc/ssh/sshd_config'))
