import subprocess
import os
import general


def set_bootloader_pw():
    return general.grep(r"^set superusers", "/boot/grub/grub.cfg") and general.grep(r"^password", "/boot/grub/grub.cfg")


def core_dumps():
    return (general.grep(r"^hard core 0", "/etc/security/limits.conf", "/etc/security/limits.d/*")
            and general.search_command_result("sysctl fs.suid_dumpable", r"fs\.suid_dumpable ?= ?0")
            and general.grep(r"fs\.suid_dumpable ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_core_dumps():
    if general.grep(r"^hard core 0", "/etc/security/limits.conf", "/etc/security/limits.d/*") == False:
        general.sed(r"^hard core 1","hard core 0","/etc/security/limits.conf")
    if general.grep(r"fs\.suid_dumpable ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"fs\.suid_dumpable ?= ?1","fs.suid_dumpable = 0","/etc/sysctl.conf")
    if general.search_command_result("sysctl fs.suid_dumpable", r"fs\.suid_dumpable ?= ?0") == False:
        general.write_sysctl("fs.suid_dumpable=0")
    return core_dumps()


def aslr():
    return (general.search_command_result("sysctl kernel.randomize_va_space", r"kernel.randomize_va_space = 2")
            and general.grep(r"kernel.randomize_va_space ?= ? 2$", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_aslr():
    if general.grep(r"kernel.randomize_va_space ?= ? 2$", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"kernel.randomize_va_space ?= ?[0-9]{1,2}","kernel.randomize_va_space = 2","/etc/sysctl.conf")
    general.write_sysctl("kernel.randomize_va_space=2")
    return aslr()


def fix_prelink():
    general.call("prelink", "-ua")
    return (general.uninstall("prelink"))
