import general


def ip_forwarding():
    return (general.search_command_result("sysctl net.ipv4.ip_forward", r"net\.ipv4\.ip_forward ?= ?0")
            and general.grep(r"^net\.ipv4\.ip_forward ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.search_command_result("sysctl net.ipv6.conf.all.forwarding", r"net\.ipv6\.conf\.all\.forwarding ?= ?0")
            and general.grep(r"^net\.ipv6\.conf\.all\.forwarding ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_ip_forwarding():
    if general.grep(r"^net\.ipv4\.ip_forward ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.ip_forward ?= ?1","net.ipv4.ip_forward = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv6\.conf\.all\.forwarding ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv6\.conf\.all\.forwarding ?= ?[0-1]","net.ipv6.conf.all.forwarding = 0","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.ip_forward=0")
    general.write_sysctl("net.ipv6.conf.all.forwarding=0")
    general.write_sysctl("net.ipv4.route.flush=1")
    general.write_sysctl("net.ipv6.route.flush=1")
    return ip_forwarding()


def packet_redirecting():
    return (general.search_command_result("sysctl net.ipv4.conf.all.send_redirects", r"net\.ipv4\.conf\.all\.send_redirects ?= ?0")
            and general.search_command_result("sysctl net.ipv4.conf.default.send_redirects", r"net\.ipv4\.conf\.default\.send_redirects ?= ?0")
            and general.grep(r"^net\.ipv4\.conf\.all\.send_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv4\.conf\.default\.send_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_packet_redirecting():
    if general.grep(r"^net\.ipv4\.conf\.all\.send_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.all\.send_redirects ?= ?1","net.ipv4.conf.all.send_redirects = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv4\.conf\.default\.send_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.default\.send_redirects ?= ?1","net.ipv4.conf.default.send_redirects = 0","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.conf.all.send_redirects=0")
    general.write_sysctl("net.ipv4.conf.default.send_redirects=0")
    general.write_sysctl("net.ipv4.route.flush=1")
    return (packet_redirecting())


def no_source_routed_packets():
    return (general.search_command_result("sysctl net.ipv4.conf.all.accept_source_route", r"net\.ipv4\.conf\.all\.accept_source_route ?= ?0")
            and general.search_command_result("sysctl net.ipv4.conf.default.accept_source_route", r"net\.ipv4\.conf\.default\.accept_source_route ?= ?0")
            and general.grep(r"^net\.ipv4\.conf\.all\.accept_source_route ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv4\.conf\.default\.accept_source_route ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.search_command_result("sysctl net.ipv6.conf.all.accept_source_route", r"net\.ipv6\.conf\.all\.accept_source_route ?= ?0")
            and general.search_command_result("sysctl net.ipv6.conf.default.accept_source_route", r"net\.ipv6\.conf\.default\.accept_source_route ?= ?0")
            and general.grep(r"^net\.ipv6\.conf\.all\.accept_source_route ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv6\.conf\.default\.accept_source_route ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_no_source_routed_packets():
    if general.grep(r"^net\.ipv4\.conf\.all\.accept_source_route ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.all\.accept_source_route ?= ?1","net.ipv4.conf.all.accept_source_route = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv4\.conf\.default\.accept_source_route ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.default\.accept_source_route ?= ?1","net.ipv4.conf.default.accept_source_route = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv6\.conf\.all\.accept_source_route ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv6\.conf\.all\.accept_source_route ?= ?1","net.ipv6.conf.all.accept_source_route = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv6\.conf\.default\.accept_source_route ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv6\.conf\.default\.accept_source_route ?= ?1","net.ipv6.conf.default.accept_source_route = 0","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.conf.all.accept_source_route=0")
    general.write_sysctl("net.ipv4.conf.default.accept_source_route=0")
    general.write_sysctl("net.ipv6.conf.all.accept_source_route=0")
    general.write_sysctl("net.ipv6.conf.default.accept_source_route=0")
    general.write_sysctl("net.ipv4.route.flush=1")
    general.write_sysctl("net.ipv6.route.flush=1")
    return(no_source_routed_packets())


def no_icmp_redirects():
    return (general.search_command_result("sysctl net.ipv4.conf.all.accept_redirects", r"net\.ipv4\.conf\.all\.accept_redirects ?= ?0")
            and general.search_command_result("sysctl net.ipv4.conf.default.accept_redirects", r"net\.ipv4\.conf\.default\.accept_redirects ?= ?0")
            and general.grep(r"^net\.ipv4\.conf\.all\.accept_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv4\.conf\.default\.accept_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.search_command_result("sysctl net.ipv6.conf.all.accept_redirects", r"net\.ipv6\.conf\.all\.accept_redirects ?= ?0")
            and general.search_command_result("sysctl net.ipv6.conf.default.accept_redirects", r"net\.ipv6\.conf\.default\.accept_redirects ?= ?0")
            and general.grep(r"^net\.ipv6\.conf\.all\.accept_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv6\.conf\.default\.accept_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_no_icmp_redirects():
    if general.grep(r"^net\.ipv4\.conf\.all\.accept_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.all\.accept_redirects ?= ?1","net.ipv4.conf.all.accept_redirects = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv4\.conf\.default\.accept_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.default\.accept_redirects ?= ?1","net.ipv4.conf.default.accept_redirects = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv6\.conf\.all\.accept_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv6\.conf\.all\.accept_redirects ?= ?1","net.ipv6.conf.all.accept_redirects = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv6\.conf\.default\.accept_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv6\.conf\.default\.accept_redirects ?= ?1","net.ipv6.conf.default.accept_redirects = 0","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.conf.all.accept_redirects=0")
    general.write_sysctl("net.ipv4.conf.default.accept_redirects=0")
    general.write_sysctl("net.ipv6.conf.all.accept_redirects=0")
    general.write_sysctl("net.ipv6.conf.default.accept_redirects=0")
    general.write_sysctl("net.ipv4.route.flush=1")
    general.write_sysctl("net.ipv6.route.flush=1")
    return (no_icmp_redirects())


def no_secure_icmp_redirects():
    return (general.search_command_result("sysctl net.ipv4.conf.all.secure_redirects", r"net\.ipv4\.conf\.all\.secure_redirects ?= ?0")
            and general.search_command_result("sysctl net.ipv4.conf.default.secure_redirects", r"net\.ipv4\.conf\.default\.secure_redirects ?= ?0")
            and general.grep(r"^net\.ipv4\.conf\.all\.secure_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv4\.conf\.default\.secure_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_no_secure_icmp_redirects():
    if general.grep(r"^net\.ipv4\.conf\.all\.secure_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.all\.secure_redirects ?= ?1","net.ipv4.conf.all.secure_redirects = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv4\.conf\.default\.secure_redirects ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.default\.secure_redirects ?= ?1","net.ipv4.conf.default.secure_redirects = 0","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.conf.all.secure_redirects=0")
    general.write_sysctl("net.ipv4.conf.default.secure_redirects=0")
    general.write_sysctl("sysctl -w net.ipv4.route.flush=1")
    return no_secure_icmp_redirects()


def suspicious_packets_logged():
    return (general.search_command_result("sysctl net.ipv4.conf.all.log_martians", r"net\.ipv4\.conf\.all\.log_martians ?= ?1")
            and general.search_command_result("sysctl net.ipv4.conf.default.log_martians", r"net\.ipv4\.conf\.default\.log_martians ?= ?1")
            and general.grep(r"^net\.ipv4\.conf\.all\.log_martians ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv4\.conf\.default\.log_martians ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_suspicious_packets_logged():
    if general.grep(r"^net\.ipv4\.conf\.all\.log_martians ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.all\.log_martians ?= ?0","net.ipv4.conf.all.log_martians = 1","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv4\.conf\.default\.log_martians ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.default\.log_martians ?= ?0","net.ipv4.conf.default.log_martians = 1","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.conf.all.log_martians=1")
    general.write_sysctl("net.ipv4.conf.default.log_martians=1")
    general.write_sysctl("net.ipv4.route.flush=1")
    return(suspicious_packets_logged())


def ignore_broadcast_icmp_requests():
    return (general.search_command_result("sysctl net.ipv4.icmp_echo_ignore_broadcasts", r"net\.ipv4\.icmp_echo_ignore_broadcasts ?= ?1")
            and general.grep(r"^net\.ipv4\.icmp_echo_ignore_broadcasts ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_ignore_broadcast_icmp_requests():
    if general.grep(r"^net\.ipv4\.icmp_echo_ignore_broadcasts ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.icmp_echo_ignore_broadcasts ?= ?0","net.ipv4.icmp_echo_ignore_broadcasts = 1","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.icmp_echo_ignore_broadcasts=1 ")
    general.write_sysctl("net.ipv4.route.flush=1")
    return ignore_broadcast_icmp_requests()


def ignore_bogus_icmp_responses():
    return (general.search_command_result("sysctl net.ipv4.icmp_ignore_bogus_error_responses", r"net\.ipv4\.icmp_ignore_bogus_error_responses ?= ?1")
            and general.grep(r"^net\.ipv4\.icmp_ignore_bogus_error_responses ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_ignore_bogus_icmp_responses():
    if general.grep(r"^net\.ipv4\.icmp_ignore_bogus_error_responses ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.icmp_ignore_bogus_error_responses ?= ?0","net.ipv4.icmp_ignore_bogus_error_responses = 1","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.icmp_ignore_bogus_error_responses=1")
    general.write_sysctl("net.ipv4.route.flush=1")
    return ignore_bogus_icmp_responses()


def no_reverse_path_filtering():
    return (general.search_command_result("sysctl net.ipv4.conf.all.rp_filter", r"net\.ipv4\.conf\.all\.rp_filter ?= ?1")
            and general.search_command_result("sysctl net.ipv4.conf.default.rp_filter", r"net\.ipv4\.conf\.default\.rp_filter ?= ?1")
            and general.grep(r"^net\.ipv4\.conf\.all\.rp_filter ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv4\.conf\.default\.rp_filter ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_no_reverse_path_filtering():
    if general.grep(r"^net\.ipv4\.conf\.all\.rp_filter ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.all\.rp_filter ?= ?0","net.ipv4.conf.all.rp_filter = 1","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv4\.conf\.default\.rp_filter ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.conf\.default\.rp_filter ?= ?0","net.ipv4.conf.default.rp_filter = 1","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.conf.all.rp_filter=1")
    general.write_sysctl("net.ipv4.conf.default.rp_filter=1")
    general.write_sysctl("net.ipv4.route.flush=1")
    return(no_reverse_path_filtering())


def tcp_syn_cookies():
    return (general.search_command_result("sysctl net.ipv4.tcp_syncookies", r"net\.ipv4\.tcp_syncookies ?= ?1")
            and general.grep(r"^net\.ipv4\.tcp_syncookies ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_tcp_syn_cookies():
    if general.grep(r"^net\.ipv4\.tcp_syncookies ?= ?1", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv4\.tcp_syncookies ?= ?0","net.ipv4.tcp_syncookies = 1","/etc/sysctl.conf")
    general.write_sysctl("net.ipv4.tcp_syncookies=1")
    general.write_sysctl("net.ipv4.route.flush=1")
    return tcp_syn_cookies()


def no_router_adds():
    return (general.search_command_result("sysctl net.ipv6.conf.all.accept_ra", r"net\.ipv6\.conf\.all\.accept_ra ?= ?0")
            and general.search_command_result("sysctl net.ipv6.conf.default.accept_ra", r"net\.ipv6\.conf\.default\.accept_ra ?= ?0")
            and general.grep(r"^net\.ipv6\.conf\.all\.accept_ra ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*")
            and general.grep(r"^net\.ipv6\.conf\.default\.accept_ra ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*"))


def fix_no_router_adds():
    if general.grep(r"^net\.ipv6\.conf\.all\.accept_ra ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv6\.conf\.all\.accept_ra ?= ?1","net.ipv6.conf.all.accept_ra = 0","/etc/sysctl.conf")
    if general.grep(r"^net\.ipv6\.conf\.default\.accept_ra ?= ?0", "/etc/sysctl.conf", "/etc/sysctl.d/*") == False:
        general.sed(r"^net\.ipv6\.conf\.default\.accept_ra ?= ?1","net.ipv6.conf.default.accept_ra = 0","/etc/sysctl.conf")
    general.write_sysctl("net.ipv6.conf.all.accept_ra=0")
    general.write_sysctl("net.ipv6.conf.default.accept_ra=0")
    general.write_sysctl("net.ipv6.route.flush=1")
    return(no_router_adds())
