# IT Sicherheit

Dieses Dokument beschreibt die Nutzung des IT-Security Checkers für Linux.

Dieses Programm überprüft alle sicherheitsrelevanten Einstellungen in Linux und ändert diese bei Bedarf automatisch.

## Vorraussetzungen

### Getestete Distributionen

- Ubuntu
- Debian

### Benötigte Pakete

- systemd
- procps
- Python3 *(>= 3.6)*

Diese Pakte können beispielsweise wie folgt nachinstalliert werden:

```bash
sudo apt-get install systemd procps python3
```

## Nutzung

### Entpacken vom Archiv

```bash
tar axvf it-sicherheit.tar.gz
```

### Ausführung

```bash
sudo python3 it-sicherheit
```

!!! question Wieso `sudo`?
    Wir empfehlen die Ausführung mit root Rechten (mit `sudo`), da einige Einstellung nur mit erhöhten Rechten eingesehen und repariert werden können.

Nach der Ausführung öffnet sich der Browser mit der Adresse [localhost:8080](http://localhost:8080). Alle Fehleinstellung werden nur mit einem roten Warndreieck gezeichnet und können über die *QuickActions* (unten rechts) repariert werden.

### Überprüfen

Die Überprüfung des Systems erfolgt automatisch, sobald über den Browser die Webseite [localhost:8080](http://localhost:8080) aufgerufen wird.

### Fehleinstellungen Korrigiern

Nach der Überprüfung können die Einstellungen mit einem roten Warndreick über die Checkbox auf der linken Seite markiert werden. Um die markierten Einstellungen zu korrigieren muss über die *QuickActions* (unten rechts) auf `Fix Issues` geklickt werden. Die Korrektur kann einige Minuten in Anspruch nehmen, laden Sie die Seite deshalb nicht neu.

## Erweiterung

Die angezeigten Regeln können erweitert und auch angepasst werden, dazu muss nur die `settings.json` Datei entsprechend angepasst werden. Jeder Regeltyp ist wie folgt aufgebaut:

- `name`: Der Anzeigename der Regel.
- `priority`: Die Wichtigkeit der Regel. Folgende Werte sind erlaubt: `low`, `medium` und `high`.
- `type`: Der Typ der Regel, also ob die Regel eine Oberkategorie (`category`) oder der Code (`py`) der quasi die Regel selbst testet.
- `description`: Zusätzliche Beschreibung die in der UI als Tooltip angezeigt wird.

### Typ: `category`

Dieser Typ hat zusätzlich noch `children`, in denen Unterkategorien eingespeichert werden können.

### Typ: `py`

Dieser Typ hat zusätzlich `check` und `fix`, in denen Python-Befhele für das Überprüfen und das Korrigieren hinterlegt sind.
